#include	"pic18.h"
#include "delay.h"
#include "lcd.h"
#include <stdio.h>

__CONFIG(1, 0x26FF);		//
__CONFIG(2, 0x00FF);		//   
__CONFIG(4, 0xFF80);


//*************      ***************//
#define bitset(var,bitno) ((var) |= 1 << (bitno))	//  
#define bitclr(var,bitno) ((var) &= ~(1 << (bitno)))//  
#define togglebit(x,y) (x^=(1<<y))					//  
#define bitret(var,bitno) ((var) & (1 << bitno))	//  
#define true 1
#define false 0
//********************************************************//

long period =0;
long frec ;
float frec_fl = 0;
static bit fl=0;

char regim=0;

void main()
{
float tmp ;
unsigned int tmp2;

T08BIT=0;
T0CS = 0;

DelayMs(10);
lcd_init();

INT0IF=0;
INT0IE=1;

PEIE=1;
GIE=1;

while(1)
{
DelayMs(100);

if(fl)
{

period+=24;
tmp = (float)(period);
frec_fl = (10000000/tmp);
lcd_gotoxy (0, 0);

if(regim==0)
{
	if(frec_fl<100)
	{
	printf ("Fr= %3.2f Hz       ", frec_fl);
	}
	else if (frec_fl<1000)
	{
	tmp2 = (frec_fl*10);
	frec_fl = tmp2/10;
	printf ("Fr= %3.1f Hz       ", frec_fl);
	}
	else
	{
	frec_fl = frec_fl/1000 ;
	printf ("Fr= %3.2f KHz       ", frec_fl);
	
	}
}
else
{
	if(frec<100000)
	{
		tmp = (float)(frec);
		tmp = tmp/1000;
		printf ("Fr= %3.3f KHz       ", tmp);
	}
	else if (frec<1000000)
	{
		frec=frec/10;
		tmp = (float)(frec);
		tmp = tmp/100;
		printf ("Fr= %3.2f KHz       ", tmp);
	}
	else
	{
		frec=frec/1000;
		tmp = (float)(frec);
		tmp = tmp/1000;
		printf ("Fr= %3.3f MHz       ", tmp);
	}
}

fl=0;
}

}
}


unsigned int tmr1_2;
signed long per_tmp =0;

void interrupt int_all()
{
char tmp;
static int ms = 199; 


if(INT0IF & INT0IE)
{
INT0IF = 0;

per_tmp +=TMR1;

if(regim==0 && per_tmp<10000)
{
INT0IE = 0; //   
regim=1;
TMR1ON=1;
TMR1=0;
TMR1CS=1;	//    
T1SYNC=0;

TMR3ON=1;
TMR3IF=0;
TMR3=65536-50000;
TMR3IE=1;
per_tmp =0;
ms = 200;

}
else
{
TMR1=0;
TMR1ON=1;
TMR1CS=0;	//    
TMR1IE=1;
TMR1IF=0;

regim=0;
period = per_tmp;
fl=1;
per_tmp = 0;



}

}


if(TMR1IF)
{
TMR1IF = 0;
per_tmp +=65536;
}


if(TMR3IF)
{
TMR3=TMR3+(65536-50000);
TMR3IF = 0;

ms--;
if(ms==0)
{
per_tmp +=TMR1;
frec  = per_tmp-2;
INT0IE = 1; //   
INT0IF=0;
TMR3ON=0;
//per_tmp =11000;
fl=1;
}

}

}

